<!DOCTYPE html>
<html lang="en">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<html xmlns:th="http://www.thymeleaf.org">
<head>
    <meta charset="UTF-8">
    <title>Title</title>
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css" integrity="sha384-JcKb8q3iqJ61gNV9KGb8thSsNjpSL0n8PARn9HuZOnIxN0hoP+VmmDGMN5t9UJ0Z" crossorigin="anonymous">
    <link href="../static/styles/styles.css" th:href="@{/styles/styles.css}" rel="stylesheet" />
</head>
<body>
<script th:inline="javascript">
    function setDate(id, created, edited) {
        let date = edited
        let string = "updated"
        if(edited == null) {
            date = created
            string = "created"
        }
        date = new Date(date.split("T")[0])
        //Days ago
        let diff = Math.floor((new Date().getTime() - date.getTime()) / (86400000))
        if(diff <= 0) {
            document.getElementById("dated" + id).innerText = string + " today"
        }
        else if(diff > 30) {
            document.getElementById("dated" + id).innerText = string + " " + Math.floor(diff/30) + " months ago"
        }
        else {
            document.getElementById("dated" + id).innerText = string + " " + diff + " days ago"
        }
    }
</script>

<!-- ALERT -->
<div th:if="${deleted}" class="alert alert-success alert-dismissible fade show" role="alert" style="width: fit-content; left: 0px; right: 0px; position:absolute; top: 0px; margin: auto; text-align: center">
    <strong>Sucessfully deleted the notice</strong>
    <button type="button" class="close" data-dismiss="alert" aria-label="Close">
        <span aria-hidden="true">&times;</span>
    </button>
</div>

<div id="failed" class="alert alert-success alert-dismissible fade show" role="alert" style="display: none; width: fit-content; left: 0px; right: 0px; position:absolute; top: 0px; margin: auto; text-align: center">
    <strong>Failed to create.</strong>
    <button type="button" class="close" data-dismiss="alert" aria-label="Close">
        <span aria-hidden="true">&times;</span>
    </button>
</div>

<!-- Modal -->
<div class="modal fade" id="staticBackdrop" data-backdrop="static" data-keyboard="false" tabindex="-1" aria-labelledby="staticBackdropLabel" aria-hidden="true">
    <div th:if="!${loggedIn}" >
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="staticBackdropLabel">Login</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <div class="col">
                        <span class="lead"> Username </span>
                        <input type="text" id="username" class="form-control" placeholder="Enter your username" aria-label="Example text with button addon" aria-describedby="button-addon1" style="border-left: none; border-right: none; border-top: none;">
                    </div>
                    <div class="col">
                        <span class="lead"> password </span>
                        <input type="password" id="password" class="form-control" placeholder="Enter your password" aria-label="Example text with button addon" aria-describedby="button-addon1" style="border-left: none; border-right: none; border-top: none;">
                    </div>
                    <p id="errorMSG" class="lead" style="color:red; display: none">Invalid credentials</p>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                    <button type="button" class="btn btn-primary" onclick="login()">Login</button>
                </div>
            </div>
        </div>
    </div>
    <!-- If logged in we show the creation modal instead -->
    <div th:if="${loggedIn}">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">New notice</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <span class="lead"> Title </span>
                    <input type="text" id="title" class="form-control" placeholder="Enter title" aria-label="Example text with button addon" aria-describedby="button-addon1" style="border-left: none; border-right: none; border-top: none;">
                    <span class="lead"> Image url </span>
                    <input type="text" id="url" placeholder="Not requiered" oninput="checkImage(this)" class="form-control" aria-label="Example text with button addon" aria-describedby="button-addon1" style="border-left: none; border-right: none; border-top: none;">
                    <img id="image" src="" style="right: 2vw;top: 3vh;max-width: 40px; max-height: 40px;position: absolute"/>
                    <p class="lead"> Text </p>
                    <textarea id="text" class="form-control" aria-label="With textarea"></textarea>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                    <button type="button" class="btn btn-primary" onclick="save()">Create</button>
                </div>
            </div>
        </div>
    </div>
</div>








<div class="mainBody">
    <div class="row">
        <div class="col">
            <blockquote class="blockquote">
                <p class="mb-0">Perhaps the best notice board ever</p>
                <footer class="blockquote-footer">Someone famous</footer>
            </blockquote>
        </div>
        <div th:switch="${loggedIn}">
            <div th:case="${true}" class="col" style="text-align: right; margin: auto">
                <a class="lead respFont" data-toggle="modal" data-target="#staticBackdrop" >[Create new]</a>
                <a class="lead respFont" href ="/logout" >[Logout]</a>
            </div>
            <div th:case="${false}" class="col" style="text-align: right; margin: auto; width:100%; height: 100%;">
                <a class="lead respFont" data-toggle="modal" style="float:bottom;" data-target="#staticBackdrop">[Login]</a>
            </div>
        </div>
    </div>
    <hr>
    <p class="lead" th:if="${notices.size()} >0 " th:text="${'(' + notices.size() + ') notices'}">
    <br><br>
    <p class ="lead" th:if="${notices.size()} < 1" >There are no notices..</p>
    <ul th:each="notice : ${notices}" class="list-group list-group-flush">
        <li class="list-group-item lead respFont" style="font-size: max(1.0vw, 14px); border-bottom: aliceblue 2px solid">
            <a th:href="@{/notice/{id}(id=${notice.id})}" style="text-decoration: none; color: black">
            <div class="row">
                <img onerror="this.src='https://i.pinimg.com/originals/59/49/17/594917932d12adfd7d662acf7dd09ecd.png';" style="max-height: 40px; max-width: 40px; min-width: 40px; max-width: 40px;" th:src="${notice.url}">

                <div class="col" style="margin:auto; " th:utext="${notice.title}"/>

                <div class="col" style="margin: auto;text-align: center" th:utext="${notice.createdBy}" />
                <div class="col" style="margin:auto; text-align: right">
                    <svg width="1em" height="1em" viewBox="0 0 16 16" class="bi bi-chat-left" fill="currentColor" xmlns="http://www.w3.org/2000/svg">
                        <path fill-rule="evenodd" d="M14 1H2a1 1 0 0 0-1 1v11.586l2-2A2 2 0 0 1 4.414 11H14a1 1 0 0 0 1-1V2a1 1 0 0 0-1-1zM2 0a2 2 0 0 0-2 2v12.793a.5.5 0 0 0 .854.353l2.853-2.853A1 1 0 0 1 4.414 12H14a2 2 0 0 0 2-2V2a2 2 0 0 0-2-2H2z"/>
                    </svg>
                    <span th:utext="${notice.replies.size()}" />
                    <svg width="1em" height="1em" viewBox="0 0 16 16" class="bi bi-eye" fill="currentColor" xmlns="http://www.w3.org/2000/svg">
                        <path fill-rule="evenodd" d="M16 8s-3-5.5-8-5.5S0 8 0 8s3 5.5 8 5.5S16 8 16 8zM1.173 8a13.134 13.134 0 0 0 1.66 2.043C4.12 11.332 5.88 12.5 8 12.5c2.12 0 3.879-1.168 5.168-2.457A13.134 13.134 0 0 0 14.828 8a13.133 13.133 0 0 0-1.66-2.043C11.879 4.668 10.119 3.5 8 3.5c-2.12 0-3.879 1.168-5.168 2.457A13.133 13.133 0 0 0 1.172 8z"/>
                        <path fill-rule="evenodd" d="M8 5.5a2.5 2.5 0 1 0 0 5 2.5 2.5 0 0 0 0-5zM4.5 8a3.5 3.5 0 1 1 7 0 3.5 3.5 0 0 1-7 0z"/>
                    </svg>
                    <span th:utext="${notice.views}" />
                </div>
                <div class="col" th:id="'dated' + ${notice.id}" style="margin:auto; text-align: right">
                    <script th:inline="javascript">
                        setDate([[${notice.id}]], [[${notice.created}]], [[${notice.lastEdited}]])
                    </script>
                </div>
            </div></a></li>
    </ul>
    </table>

</div>
</body>
<script src="https://code.jquery.com/jquery-3.5.1.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
<script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.1/dist/umd/popper.min.js" integrity="sha384-9/reFTGAW83EW2RDu2S0VKaIzap3H66lZH81PoYlFhbGU+6BZp6G7niu735Sk7lN" crossorigin="anonymous"></script>
<script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js" integrity="sha384-B4gt1jrGC7Jh4AgTPSdUtOBvfO8shuf57BaghqFfPlYxofvL8/KUEfYiJOMMV+rV" crossorigin="anonymous"></script>
<script>
    function login() {
        let error = false;
        fetch("/login", {
            method: "POST",
            body: JSON.stringify({
                name: document.getElementById("username").value,
                password: document.getElementById("password").value
            }),
            headers: {
                'Content-Type': 'application/json'
            }
        })
            .then(resp => {
                console.log(resp.status)
                if(resp.status !== 202) {
                    error = true;
                }
                return resp.json();
            })
            .then(json => {
                if (!error) {
                    location.reload();
                }
                else {
                    document.getElementById("errorMSG").style.display = "block"
                }
            })
    }

    function checkImage(t) {
        if(validURL(t.value)) {
            document.getElementById("image").src = t.value
        }
    }

    function validURL(str) {
        var pattern = new RegExp('^(https?:\\/\\/)?'+ // protocol
            '((([a-z\\d]([a-z\\d-]*[a-z\\d])*)\\.)+[a-z]{2,}|'+ // domain name
            '((\\d{1,3}\\.){3}\\d{1,3}))'+ // OR ip (v4) address
            '(\\:\\d+)?(\\/[-a-z\\d%_.~+]*)*'+ // port and path
            '(\\?[;&a-z\\d%_.~+=-]*)?'+ // query string
            '(\\#[-a-z\\d_]*)?$','i'); // fragment locator
        return !!pattern.test(str);
    }

    function save() {
        let title = document.getElementById("title").value
        let url = document.getElementById("url").value
        let text = document.getElementById("text").value
        if(text.trim() == "" || title.trim() == "") {
            $('#saveButton').attr('data-content', "Title & text cant be empty.").popover('show')
            setTimeout(() => {
                $('#saveButton').popover('dispose')
            }, 3500)
        }
        else {
            let error = false
            fetch("/notice", {
                method: "POST",
                body: JSON.stringify({title, text, url}),
                headers: {
                    'Content-Type': 'application/json'
                }
            })
                .then(resp => {
                    if(resp.status !== 201) {
                        error = true;
                    }
                    return resp.json()
                })
                .then(data => {
                    if(!error) {
                        window.location.href = "/redirectIndex/created/" + data.data.id
                    }
                    else {
                        document.getElementById("failed").style.display = "block"
                    }
                })
        }

    }
</script>

</html>